<?php

/**
 * formula actions.
 *
 * @package    nomina
 * @subpackage formula
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class formulaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'NO_FORMULA',
        'NO_CONCEPTOS_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'NO_CONCEPTOS_V' =>
        array(
            'id_concep_nomina' => 'NO_FORMULA'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'NO_FORMULA' =>
        array(
            'id_formula' => 'id_formula',
            'id_concep_nomina' => 'id_concep_nomina',
            'formula' => 'formula',
            'nombre' => 'nombre',
            'cod_tipo' => 'cod_tipo'
        ),
        'NO_CONCEPTOS_V' =>
        array(
            'codigo' => 'codigo',
            'descripcion' => 'descripcion',
            'codigo,||, - ,||,descripcion' => 'completo',
            'id_tipo_concepto' => 'id_tipo_concepto',
            'abreviatura' => 'abreviatura',
            'operador' => 'operador',
            'operadoropcional' => 'operadoropcional',
            'cod2' => 'cod2',
            'cod3' => 'cod3',
            'id_concep_ajuste' => 'id_concep_ajuste',
            'id_concep_rein' => 'id_concep_rein',
            'id_acreedor' => 'id_acreedor',
            'id_rubro' => 'id_rubro',
            'id_cpo' => 'id_cpo',
            'estado' => 'estado',
            'aplica_descuento' => 'aplica_descuento',
            'id_clase_fondo' => 'id_clase_fondo',
            'usa_dias_calen' => 'usa_dias_calen'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'NO_FORMULA' => array(
            'id_formula,a' => array('!=' => array(-1)),
            'id_formula,b' => array('=' => array('id_formula')),
            'id_concep_nomina' => array('=' => array('id_concep_nomina')),
            'nombre' => array('LIKE' => array('nombre', '%')),
            'cod_tipo' => array('=' => array('cod_tipo')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'NO_CONCEPTOS_V' => array(
            'id_tipo_concepto' => array('=' => array('id_tipo_concepto')),
            'id_clase_fondo' => array('=' => array('id_clase_fondo')),
            'id_acreedor' => array('=' => array('id_acreedor'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
//    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas
    protected $fields_orderBy = array(
        'nombre'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_formula'; //identificador de la tabla
    protected $id_names = array('id_formula'); //llave primaria
    protected $field_names = array('id_concep_nomina', 'formula', 'nombre', 'cod_tipo'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'NO_FORMULA'; //tabla en la cual se aplican los cambios
    protected $has_activo = false; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_formula'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */


        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $request['formula'] = str_replace("&lt;", "<", $request['formula']);
            $request['formula'] = str_replace("&gt;", ">", $request['formula']);
            $request['formula'] = str_replace("&#039;", "'", $request['formula']);
            $request['formula'] = str_replace("&nbsp;", " ", $request['formula']);
            $request['formula'] = str_replace("&amp;", "&", $request['formula']);
        }

        //accion update
        if ($Action == "UPDATE") {
            $request['formula'] = str_replace("&lt;", "<", $request['formula']);
            $request['formula'] = str_replace("&gt;", ">", $request['formula']);
            $request['formula'] = str_replace("&#039;", "'", $request['formula']);
            $request['formula'] = str_replace("&nbsp;", " ", $request['formula']);
            $request['formula'] = str_replace("&amp;", "&", $request['formula']);
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = ' ORDER BY tab0.codigo, tab0.formula ';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo = $request['id_periodo'];

            /*
             * Variables opcionales
             */
            //cod_tipo
            if (isset($request['id_tipo_formula'])) {
                $whereTipoFormula = " AND tab0.cod_tipo = '" . $request['id_tipo_formula'] . "' ";
            } else {
                $whereTipoFormula = ' ';
            }
            //id_concep_nomina
            if (isset($request['id_concep_nomina'])) {
                $whereConcepto = " AND tab0.id_concep_nomina = " . $request['id_concep_nomina'];
            } else {
                $whereConcepto = ' ';
            }
            //id_agrup_concepto
            if (isset($request['id_agrup_concepto'])) {
                $whereConceptoAgrup = " and tab0.id_concep_nomina in ( select no_agrup_deta.id_concep_nomina from no_agrup_deta where no_agrup_deta.id_agrup_concepto = " . $request['id_agrup_concepto'] . " ) ";
            } else {
                $whereConceptoAgrup = ' ';
            }
            //con_tip_val
            if (isset($request['con_tip_val'])) {
                $whereConTipoValor = " AND tab0.formula_mod like '%" . $request['con_tip_val'] . "%' ";
            } else {
                $whereConTipoValor = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (
    
select tab0.* 
from (
    
    SELECT   
    tab0.id_formula as id_formula, 
    tab0.id_concep_nomina as id_concep_nomina, 
    tab0.formula as formula, 
    tab0.nombre as nombre, 
    tab0.cod_tipo as cod_tipo, 
    tab1.codigo as codigo, 
    tab1.descripcion as descripcion, 
    tab1.codigo||' - '||tab1.descripcion as completo, 
    tab1.id_tipo_concepto as id_tipo_concepto, 
    tab1.abreviatura as abreviatura, 
    tab1.operador as operador, 
    tab1.operadoropcional as operadoropcional, 
    tab1.cod2 as cod2, 
    tab1.cod3 as cod3, 
    tab1.id_concep_ajuste as id_concep_ajuste, 
    tab1.id_concep_rein as id_concep_rein, 
    tab1.id_acreedor as id_acreedor, 
    tab1.id_rubro as id_rubro, tab1.id_cpo as id_cpo, 
    tab1.estado as estado, 
    tab1.aplica_descuento as aplica_descuento, 
    tab1.id_clase_fondo as id_clase_fondo, 
    tab1.usa_dias_calen as usa_dias_calen,
    tipfor.nombre_tipo_formula,                    
    tab0.formula_mod as formula_mod
    
    FROM NO_FORMULA tab0  
    
    JOIN NO_CONCEPTOS_V tab1 
    ON tab0.id_concep_nomina = tab1.id_concep_nomina 
    
    left join NO_TIPO_FORMULA_V tipfor on tipfor.id_tipo_formula = tab0.cod_tipo
    
    WHERE  
    tab0.id_formula != '-1'     
                    
    $whereTipoFormula $whereConcepto $whereConceptoAgrup  

)tab0

where
1 = 1   
                    
$whereConTipoValor                    
    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
    
select tab0.* 
from (
    
    SELECT   
    tab0.id_formula as id_formula, 
    tab0.id_concep_nomina as id_concep_nomina, 
    tab0.formula as formula, 
    tab0.nombre as nombre, 
    tab0.cod_tipo as cod_tipo, 
    tab1.codigo as codigo, 
    tab1.descripcion as descripcion, 
    tab1.codigo||' - '||tab1.descripcion as completo, 
    tab1.id_tipo_concepto as id_tipo_concepto, 
    tab1.abreviatura as abreviatura, 
    tab1.operador as operador, 
    tab1.operadoropcional as operadoropcional, 
    tab1.cod2 as cod2, 
    tab1.cod3 as cod3, 
    tab1.id_concep_ajuste as id_concep_ajuste, 
    tab1.id_concep_rein as id_concep_rein, 
    tab1.id_acreedor as id_acreedor, 
    tab1.id_rubro as id_rubro, tab1.id_cpo as id_cpo, 
    tab1.estado as estado, 
    tab1.aplica_descuento as aplica_descuento, 
    tab1.id_clase_fondo as id_clase_fondo, 
    tab1.usa_dias_calen as usa_dias_calen,
    tipfor.nombre_tipo_formula,                    
    tab0.formula_mod as formula_mod
    
    FROM NO_FORMULA tab0  
    
    JOIN NO_CONCEPTOS_V tab1 
    ON tab0.id_concep_nomina = tab1.id_concep_nomina 
    
    left join NO_TIPO_FORMULA_V tipfor on tipfor.id_tipo_formula = tab0.cod_tipo
    
    WHERE  
    tab0.id_formula != '-1'     
                    
    $whereTipoFormula $whereConcepto $whereConceptoAgrup  

)tab0

where
1 = 1   
                    
$whereConTipoValor 
                    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[formula] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
